function ghtl_kfold_wrapper_function(C,mu,d_0,d_v,rho,maxactive,inverted,w)

mltask = 'regression';%classification, regression
dataset = '';
proptrain = .20;
nfolds = 3;%cross-validation
numSplits = 10;
errType = 1;%0: error, 1: (1-AUC), 2: MSE, 3: NMSE, 4: AMSE
balanceDataset = 1;

% splits = preprocessData(data.flabels,data.ftasks,proptrain,nfolds,numSplits);
load('../journalInput/sarcosNormalized_15.mat');


mids = sort(unique(data.ftasks))';
T = length(mids);

bestCvParameter = nan(2,numSplits);
cvErrHtlCell = cell(numSplits,1);
timeTaken = zeros(1,numSplits);
errSplits = nan(numSplits,1);
avgErrHtl = 0;
outputs_locs = cell(numSplits,nfolds,length(mu));
model_locs = cell(numSplits,nfolds,length(mu));
accuracies_locs = cell(numSplits,nfolds,length(mu));
fhtl = cell(numSplits,1);
stdSplits = nan;

for sp=1:numSplits
    split = splits{sp};
    
    trainInd = cell(T,1);
    testInd = cell(T,1);
    xTrain = cell(T,1);
    xTest = cell(T,1);
    yTrain = cell(T,1);
    yTest = cell(T,1);
    
    numTrain = split.numTrain;
    numTest = split.numTest;
    xTrainArr = [];
    xTestArr = [];
    for t=1:T
        trainInd{t} = split.train( (sum(numTrain(1:(t-1)))+1):sum(numTrain(1:t)) );
        testInd{t} = split.test( (sum(numTest(1:(t-1)))+1):sum(numTest(1:t)) );
        xTrain{t} = data.fdata(trainInd{t},:);%dxn
        xTest{t} = data.fdata(testInd{t},:);%dxn
        yTrain{t} = data.flabels(trainInd{t});
        yTest{t} = data.flabels(testInd{t});
        
        xTrainArr = [xTrainArr; xTrain{t}];
        xTestArr = [xTestArr; xTest{t}];
    end
    
    meta_Ktr = nan(size(xTrainArr,1),size(xTrainArr,1));
    meta_Kte = nan(size(xTestArr,1),size(xTrainArr,1));
    count = 0;
    
    KTYPE =1;
    KSCALE = 0;
    count = 1;
    meta_Ktr(:,:,count) = kernel(xTrainArr,xTrainArr,KTYPE,KSCALE);
    meta_Ktr(:,:,count) = (meta_Ktr(:,:,count) + meta_Ktr(:,:,count)')/2;
    meta_Kte(:,:,count) = kernel(xTestArr,xTrainArr,KTYPE,KSCALE);
    
%     % featurewise linear kernels % for letters, mhc
%     % create kernels of 10 features
%     featGroup = 10;
%     for i=1:(size(xTrainArr,2)/featGroup)
%         count = count+1;
%         fea = ((i-1)*featGroup+1):(i*featGroup);
%         meta_Ktr(:,:,count) = kernel(xTrainArr(:,fea),xTrainArr(:,fea),KTYPE,KSCALE);
%         meta_Ktr(:,:,count) = (meta_Ktr(:,:,count) + meta_Ktr(:,:,count)')/2;
%         meta_Kte(:,:,count) = kernel(xTestArr(:,fea),xTrainArr(:,fea),KTYPE,KSCALE);
%     end
    
    % featurewise linear kernels % for Sarcos, yale_5, landmine, mhc, school
    % letter
    for i=1:size(xTrainArr,2)
        count = count+1;
        meta_Ktr(:,:,count) = kernel(xTrainArr(:,i),xTrainArr(:,i),KTYPE,KSCALE);
        meta_Ktr(:,:,count) = (meta_Ktr(:,:,count) + meta_Ktr(:,:,count)')/2;
        meta_Kte(:,:,count) = kernel(xTestArr(:,i),xTrainArr(:,i),KTYPE,KSCALE);
    end
    
%     % gaussian
%     KTYPE =6;
%     for i=1:length(w)
%         KSCALE = w(i);
%         count = count+1;
%         meta_Ktr(:,:,count) = kernel(xTrainArr,xTrainArr,KTYPE,KSCALE);
%         meta_Ktr(:,:,count) = (meta_Ktr(:,:,count) + meta_Ktr(:,:,count)')/2;
%         meta_Kte(:,:,count) = kernel(xTestArr,xTrainArr,KTYPE,KSCALE);
%     end
%     % featurewise gaussian
%     KTYPE =6;
%     for i=1:length(w)
%         KSCALE = w(i);
%         for ii=1:size(xTrainArr,2)
%             count = count+1;
%             meta_Ktr(:,:,count) = kernel(xTrainArr(:,ii),xTrainArr(:,ii),KTYPE,KSCALE);
%             meta_Ktr(:,:,count) = (meta_Ktr(:,:,count) + meta_Ktr(:,:,count)')/2;
%             meta_Kte(:,:,count) = kernel(xTestArr(:,ii),xTrainArr(:,ii),KTYPE,KSCALE);
%         end
%     end
    
    % cross validation for best configuration
    cvErrHtl = zeros(length(mu),length(C));

    for cv = 1:nfolds
        yTrainCV = cell(T,1);
        yTestCV = cell(T,1);
        numTrainCV = zeros(T,1);
        numTestCV = zeros(T,1);
        trIndCV = false(sum(numTrain),1);
        teIndCV = false(sum(numTrain),1);
        for t=1:T
            yTrainCV{t} = yTrain{t}(split.compfolds{t}{cv});
            yTestCV{t} = yTrain{t}(split.folds{t}{cv});
            numTrainCV(t) = length(yTrainCV{t});%size(xTrainCV{t},2);
            numTestCV(t) = length(yTestCV{t});%size(xTestCV{t},2);
            
            trIndCV(sum(numTrain(1:(t-1)))+split.compfolds{t}{cv}) = true;
            teIndCV(sum(numTrain(1:(t-1)))+split.folds{t}{cv}) = true;
        end
        
        for m=1:length(mu)
            mu_ = mu(m);
            KtrCV = meta_Ktr(trIndCV,trIndCV,:)/mu_;
            KteCV = meta_Ktr(teIndCV,trIndCV,:)/mu_;
            
            for t1=1:T
                index1 = (sum(numTrainCV(1:(t1-1)))+1):sum(numTrainCV(1:t1));
                KtrCV(index1,index1,:) = KtrCV(index1,index1,:)*(1+mu_);
                index2 = (sum(numTestCV(1:(t1-1)))+1):sum(numTestCV(1:t1));
                KteCV(index2,index1,:) = KteCV(index2,index1,:)*(1+mu_);
            end
            
                    fprintf('===%s===SPLIT %d===CV %d========\n',dataset,sp,cv);
                    fprintf('===rho %f===inverted %d=========\n',rho,inverted);
                    fprintf('===d0 %f===d_v %f===MU %f========\n',d_0,d_v,mu_);
                    cpuTime = cputime;
                    weight = [d_0 d_v];
                    [outputs_locs{sp,cv,m},model_locs{sp,cv,m},accuracies_locs{sp,cv,m}] = htl(KtrCV,yTrainCV,KteCV,yTestCV,C,weight,rho,numTrainCV,...
                        numTestCV,mu_,'maxactive',maxactive,'inverted',inverted,'mltask',mltask,'balance',balanceDataset);
                    %testing needs to be integrated
                    cpuTime = cputime-cpuTime;
                    
                    if errType == 0 % class_error
                        cvErrHtl(m,:) = cvErrHtl(m,:)+accuracies_locs{sp,cv,m}.avgTestErr;
                    elseif errType == 1 % AUC
                        cvErrHtl(m,:) = cvErrHtl(m,:)+accuracies_locs{sp,cv,m}.avgTestAuc;
                    elseif errType == 2 % MSE
                        cvErrHtl(m,:) = cvErrHtl(m,:)+accuracies_locs{sp,cv,m}.avgTestMse;
                    elseif errType == 3 % NMSE
                        cvErrHtl(m,:) = cvErrHtl(m,:)+accuracies_locs{sp,cv,m}.avgTestNmse;
                    elseif errType == 4 % AMSE
                        cvErrHtl(m,:) = cvErrHtl(m,:)+accuracies_locs{sp,cv,m}.avgTestAmse;
                    end
        end
    end
    cvErrHtlCell{sp} = cvErrHtl;
    [minCvErr,minCvIdx] = min(cvErrHtl(:));
    [bestmu,bestc] = ind2sub(size(cvErrHtl),minCvIdx);
    bestCvParameter(1,sp) = mu(bestmu);
    bestCvParameter(2,sp) = C(bestc);

    % final run
    mu_ = mu(bestmu);
    
    Ktr = meta_Ktr/mu_;
    Kte = meta_Kte/mu_;

    for t1=1:T
        index1 = (sum(numTrain(1:(t1-1)))+1):sum(numTrain(1:t1));
        Ktr(index1,index1,:) = Ktr(index1,index1,:)*(1+mu_);
        index2 = (sum(numTest(1:(t1-1)))+1):sum(numTest(1:t1));
        Kte(index2,index1,:) = Kte(index2,index1,:)*(1+mu_);
    end
    
    weight = [d_0 d_v];
    fprintf('===%s===SPLIT %d===========\n',dataset,sp);
    fprintf('===rho %f===inverted %d=========\n',rho,inverted);
    fprintf('===d0 %f===d_v %f===MU %f========\n',d_0,d_v,mu_);
    timeTaken(sp) = cputime;
    [fhtl{sp}.outputs,fhtl{sp}.model,fhtl{sp}.accuracies] = htl(Ktr,yTrain,Kte,yTest,C(bestc),weight,rho,numTrain,numTest,...
        mu_,'maxactive',maxactive,'inverted',inverted,'mltask',mltask,'balance',balanceDataset); %testing needs to be integrated
    timeTaken(sp) = cputime-timeTaken(sp);
    
    if errType==0
        errHtl = fhtl{sp}.accuracies.avgTestErr;
    elseif errType==1
        errHtl = fhtl{sp}.accuracies.avgTestAuc;
    elseif errType==2
        errHtl = fhtl{sp}.accuracies.avgTestMse;
        errHtl = fhtl{sp}.accuracies.avgTestNmse;
    elseif errType==3
        errHtl = fhtl{sp}.accuracies.avgTestNmse;
    elseif errType==4
        errHtl = fhtl{sp}.accuracies.avgTestAmse;
    end
    
    errSplits(sp) = errHtl;
    avgErrHtl = (avgErrHtl*(sp-1) + errHtl)/sp;
    stdSplits = std(errSplits(1:sp));
end

