function [predtrain,predtest] = predict_htl(K_tr,K_te,hull,alpha_t,b_t,zeta,theta,dataset,inverted,mu)

%K_tr - cell of size Txk. K_tr{t,j} - must be PD % stores YKY

% alpha_t - alpha.*Y
% b_t = Tx1 vector
% eta_hull - Rx1 vector
% zeta_hull - Rx1 vector - it is the nthroot of descNormBar
% theta_hull - Rx1 vector
% gamma_kernel - RxK matrix
numTrain = dataset.numTrain;
numTest = dataset.numTest;
singleTaskMuFactor = 1+1/mu;
if inverted
    taskDenoter = 1;
else
    taskDenoter = 2;
end
p = size(hull,1);
T = size(hull,2);
n = sum(numTrain);
kern = size(K_te,3);
zetaRep = repmat(zeta,kern,1);
theta_zeta = theta.*zetaRep;%
myRidge = 1e-8;
K2 = myRidge*eye(n,n);%train kernel
K3 = zeros(sum(numTest),n);%test kernel
k = T*(T+1)/2;%number of blocks in triu matrix. first T are for diagonal blocks
coeff = zeros(k,kern);

for i=1:p
    presentTasks = find(hull(i,:)==taskDenoter);
    for kk=1:kern
        index_zeta = (kk-1)*p+i;
        if (length(presentTasks) == 1)
            coeff([presentTasks],kk) = coeff([presentTasks],kk) + theta_zeta(index_zeta)/singleTaskMuFactor;
        else
            pairs = combntns(presentTasks,2);
            index = T + (pairs(:,1)-1).*(T-pairs(:,1)/2) + pairs(:,2) - pairs(:,1);
            coeff([presentTasks';index],kk) = coeff([presentTasks';index],kk) + theta_zeta(index_zeta);
        end
    end
end

for t1=1:T
    for t2=t1:T
        for kk=1:kern
            if t1 == t2
                index3 = t1;
                index1 = (sum(numTrain(1:(t1-1)))+1):sum(numTrain(1:t1));
                K2(index1,index1) = K2(index1,index1) + K_tr(index1,index1,kk)*coeff(index3,kk);

                index4 = (sum(numTest(1:(t1-1)))+1):sum(numTest(1:t1));
                K3(index4,index1) = K3(index4,index1) + K_te(index4,index1,kk)*coeff(index3,kk);
            else
                index3 = T + (t1-1)*(T-t1/2) + t2 - t1;
                index1 = (sum(numTrain(1:(t1-1)))+1):sum(numTrain(1:t1));
                index2 = (sum(numTrain(1:(t2-1)))+1):sum(numTrain(1:t2));
                Ktemp = K_tr(index1,index2,kk)*coeff(index3,kk);
                K2(index1,index2) = K2(index1,index2) + Ktemp;
                K2(index2,index1) = K2(index2,index1) + Ktemp';

                index4 = (sum(numTest(1:(t1-1)))+1):sum(numTest(1:t1));
                K3(index4,index2) = K3(index4,index2) + K_te(index4,index2,kk)*coeff(index3,kk);
                index5 = (sum(numTest(1:(t2-1)))+1):sum(numTest(1:t2));
                index6 = (sum(numTrain(1:(t1-1)))+1):sum(numTrain(1:t1));
                K3(index5,index6) = K3(index5,index6) + K_te(index5,index6,kk)*coeff(index3,kk);
            end
        end
    end
end

numTrain = dataset.numTrain;
numTest = dataset.numTest;

begTrIdx = [1;cumsum(numTrain(1:end-1))+1];
endTrIdx = cumsum(numTrain(1:end));
begTeIdx = [1;cumsum(numTest(1:end-1))+1];
endTeIdx = cumsum(numTest(1:end));

predtrain = K2*alpha_t;
predtest = K3*alpha_t;
% keyboard;
for t=1:T
    predtrain(begTrIdx(t):endTrIdx(t)) = b_t(t) + predtrain(begTrIdx(t):endTrIdx(t));
    predtest(begTeIdx(t):endTeIdx(t)) = b_t(t) + predtest(begTeIdx(t):endTeIdx(t));
end
