function [splits] = preprocessData(Y,tlist,proptrain,kfold,numSplits)
splits = cell(numSplits,1);
mids = sort(unique(tlist))';

% nfolds = 1;
for nfolds=1:numSplits
    splits{nfolds}.train = [];
    splits{nfolds}.test = [];
    splits{nfolds}.numTrain = zeros(length(mids),1);
    splits{nfolds}.numTest = zeros(length(mids),1);
    splits{nfolds}.folds = cell(1,1);
    splits{nfolds}.compfolds = cell(1,1);
    
    t = 0;
    Train = [];
    Test = [];
    
    for i=mids
        t = t+1;
        % Taking care of unbalanced splits
        indexpos = find((tlist == i) & (Y == 1))';
        indexneg = find((tlist == i) & (Y == -1))';
        npos = length(indexpos);
        nneg = length(indexneg);
        %     n = npos+nneg;
        npostrain = ceil(npos*proptrain);
        %     npostest = npos - npostrain;
        rppos = randperm(npos);
        postrainset = indexpos(rppos(1:npostrain));
        postestset = indexpos(rppos(npostrain+1:end));
        
        nnegtrain = ceil(nneg*proptrain);
        %     nnegtest = nneg - nnegtrain;
        rpneg = randperm(nneg);
        negtrainset = indexneg(rpneg(1:nnegtrain));
        negtestset = indexneg(rpneg(nnegtrain+1:end));
        
        ntrain = npostrain+nnegtrain;
        %     ntest = n - ntrain;
        
        trainset = [];
        for ifold=1:kfold
            if ifold<kfold
                poschunk = floor( (ifold-1)*npostrain/kfold + 1): floor( ifold*npostrain/kfold );
                negchunk = floor( (ifold-1)*nnegtrain/kfold + 1): floor( ifold*nnegtrain/kfold );
            else
                poschunk = floor( (ifold-1)*npostrain/kfold + 1):npostrain;
                negchunk = floor( (ifold-1)*nnegtrain/kfold + 1):nnegtrain;
            end
            trainset = [trainset, postrainset(poschunk), negtrainset(negchunk)];
        end
        testset = [postestset, negtestset];
        
        Train = [Train, trainset];
        Test = [Test, testset];
        [folds compfolds] = crossValidationFolds(kfold,ntrain);
        splits{nfolds}.numTrain(t) = ntrain;
        splits{nfolds}.numTest(t) = length(testset);
        splits{nfolds}.folds{t} = folds;
        splits{nfolds}.compfolds{t} = compfolds;
    end
    
    splits{nfolds}.train = Train;
    splits{nfolds}.test = Test;
end


